---
title: PostgreSQL JDBC Driver 42.2.24 Released
date: 2021-09-22 15:30:49 +0000
categories:
  - new_release
version: 42.2.24
---

### Fixed
- Fix startup regressions caused by [PR #1949](https://github.com/pgjdbc/pgjdbc/pull/1949). Instead of checking all types by OID, we can return types for well known types [PR #2257](https://github.com/pgjdbc/pgjdbc/pull/2257)
- Backport [PR #2148](https://github.com/pgjdbc/pgjdbc/pull/2148)
  Avoid leaking server error details through BatchUpdateException when logServerErrorDetail [PR #2254](https://github.com/pgjdbc/pgjdbc/pull/2254)
- Backpatch [PR #2247](https://github.com/pgjdbc/pgjdbc/pull/2247)
  QueryExecutorImpl.receiveFastpathResult did not properly handle ParameterStatus messages.
  This in turn caused failures for some LargeObjectManager operations. Closes [Issue #2237](https://github.com/pgjdbc/pgjdbc/issues/2237)
  Fixed by adding the missing code path, based on the existing handling in processResults. [PR #2253](https://github.com/pgjdbc/pgjdbc/pull/2253)
- Backpatch [PR #2242](https://github.com/pgjdbc/pgjdbc/pull/2242) PgDatabaseMetaData.getIndexInfo() cast operands to smallint  [PR#2253](https://github.com/pgjdbc/pgjdbc/pull/2253) 
  It is possible to break method PgDatabaseMetaData.getIndexInfo() by adding certain custom operators. This PR fixes it.
- Backpatching [PR #2251](https://github.com/pgjdbc/pgjdbc/pull/2251) into 42.2 Clean up open connections to fix test failures on omni and appveyor
  use older syntax for COMMENT ON FUNCTION with explicit no-arg parameter parentheses as it is required on server versions before v10.
  Handle cleanup of connection creation in StatementTest, handle cleanup of privileged connection in DatabaseMetaDataTest
- Backpatch [PR #2245](https://github.com/pgjdbc/pgjdbc/pull/2245) fixes case where duplicate tables are returned if there are duplicate descriptions oids are not guaranteed to be unique in the catalog [PR #2248](https://github.com/pgjdbc/pgjdbc/pull/2248)
- Change to updatable result set to use correctly primary or unique keys [PR #2228](https://github.com/pgjdbc/pgjdbc/pull/2228) 
    fixes issues introduced in [PR #2199](https://github.com/pgjdbc/pgjdbc/pull/2199) closes [Issue #2196](https://github.com/pgjdbc/pgjdbc/issues/2196)
- Fix NPE calling getTypeInfo when alias is null [PR #2220](https://github.com/pgjdbc/pgjdbc/pull/2220)
- Backpatch [PR #2217](https://github.com/pgjdbc/pgjdbc/pull/2217) to fix [Issue #2215](https://github.com/pgjdbc/pgjdbc/issues/2215). OIDs are unsigned integers and were not being handled correctly when they exceeded the size of signed integers


<!--more-->

**Commits by author**

Dave Cramer (7):

* fix: backpatch PR[PR 2217](https://github.com/pgjdbc/pgjdbc/pull/2217) to fix issue #2215.  (#2218) [be1d4aa0](https://github.com/pgjdbc/pgjdbc/commit/be1d4aa05f818a1d64a58462413ac1291858a2b2)
* fix: NPE calling getTypeInfo when alias is null [PR 2220](https://github.com/pgjdbc/pgjdbc/pull/2220) [77c7d94e](https://github.com/pgjdbc/pgjdbc/commit/77c7d94e05003db7bece1d7baeb059272e3bcda2)
* remove old changelog information from post. Incorrectly added by development script that is clearly still in development [PR 2240](https://github.com/pgjdbc/pgjdbc/pull/2240) [a70834e8](https://github.com/pgjdbc/pgjdbc/commit/a70834e8c5c9c2c3ab7024c5c605d3a978c00272)
* backpatch pr[PR 2245](https://github.com/pgjdbc/pgjdbc/pull/2245) fixes case where duplicate tables are returned if there are duplicate descriptions oids are not guaranteed to be unique in the catalog (#2248) [f4928cee](https://github.com/pgjdbc/pgjdbc/commit/f4928cee038543202e0f09a77348f249155fec12)
* backpatch PR[PR 2247](https://github.com/pgjdbc/pgjdbc/pull/2247) (#2249) [7bf89c8b](https://github.com/pgjdbc/pgjdbc/commit/7bf89c8b2fa2218fc37f959753da2b01be09ffc2)
* fix startup regressions caused by PR [PR 1949](https://github.com/pgjdbc/pgjdbc/pull/1949). Instead of checking all types by OID, we can return types for well known types (#2257) [88cfccab](https://github.com/pgjdbc/pgjdbc/commit/88cfccab1ce41c8fb9f238d2ff09eba969c41a02)
* Bump version to 42.2.24 and update changelog [233c5181](https://github.com/pgjdbc/pgjdbc/commit/233c51810dc34d34ebb7efcd4d4b960d626b8c53)

Jens Peters (1):

* Backport PR2148 into 42.2.x [PR 2254](https://github.com/pgjdbc/pgjdbc/pull/2254) [2917c1f2](https://github.com/pgjdbc/pgjdbc/commit/2917c1f2d448f68419c89530ffc742a3d693ed1e)

Juha Syrjälä (1):

* PgDatabaseMetaData.getIndexInfo() cast operands to smallint [PR 2242](https://github.com/pgjdbc/pgjdbc/pull/2242) (#2253) [33af6a78](https://github.com/pgjdbc/pgjdbc/commit/33af6a780af0083b382d536c909a20145d5ff195)

Sehrope Sarkuni (3):

* test: Fix database metadata to handle older versions for function comment [bb1f7285](https://github.com/pgjdbc/pgjdbc/commit/bb1f7285b7884f3d8032a637b38f49f4b2faaac1)
* test: Handle cleanup of connection creation in StatementTest [1c5f5271](https://github.com/pgjdbc/pgjdbc/commit/1c5f52712a5d6757b69effdb2c5d9eb06657a871)
* test: Handle cleanup of privileged connection in DatabaseMetaDataTest [5c6041b4](https://github.com/pgjdbc/pgjdbc/commit/5c6041b49146cecee1e360a18789197827aa6adf)

chalmagr (1):

* Fix updateable result set when there are primary keys and unique keys [PR 2228](https://github.com/pgjdbc/pgjdbc/pull/2228) [c596587a](https://github.com/pgjdbc/pgjdbc/commit/c596587aa52db6573d5cf41f29f1f6b8afe29cb5)

<a name="contributors_{{ page.version }}"></a>
### Contributors to this release

We thank the following people for their contributions to this release.

[chalmagr](https://github.com/chalmagr)  
[Dave Cramer](davec@postgresintl.com)  
[Jens Peters](https://github.com/jp7677)  
[Juha Syrjälä](https://github.com/jsyrjala)  
[Sehrope Sarkuni](https://github.com/sehrope)  
