---
title: PostgreSQL JDBC Driver 42.3.1 Released
date: 2021-10-29 15:09:25 +0000
categories:
  - new_release
version: 42.3.1
---
**Notable changes**

### Changed
- improv: Arrays in Object[] [PR 2330](https://github.com/pgjdbc/pgjdbc/pull/2330) when an Object[] contains other arrays, treat as though it were a
multi-dimensional array the one exception is byte[], which is not supported.
- improv: Use jre utf-8 decoding [PR 2317](https://github.com/pgjdbc/pgjdbc/pull/2317) Remove use of custom utf-8 decoding.
- perf: improve performance of bytea string decoding [PR 2320](https://github.com/pgjdbc/pgjdbc/pull/2320)
improve the parsing of bytea hex encoded string by making a lookup table for each of the valid ascii code points to the 4 bit numeric value
- feat: intern/canonicalize common strings [PR 2234](https://github.com/pgjdbc/pgjdbc/pull/2234)
### Added

### Fixed
- numeric binary decode for even 10 thousands [PR #2327](https://github.com/pgjdbc/pgjdbc/pull/2327) fixes  [Issue 2326](https://github.com/pgjdbc/pgjdbc/issues/2326)
binary numeric values which represented integers multiples of 10,000 from 10,000-9,990,000 were not decoded correctly
- [typo] typo in certdir/README.md [PR #2309](https://github.com/pgjdbc/pgjdbc/pull/2309) certificatess => certificates
- [typo] typo in TimestampUtils.java [PR #2314](https://github.com/pgjdbc/pgjdbc/pull/2314) Change `Greagorian` to `Gregorian`.
- remove check for negative pid in cancel request. Apparently pgbouncer can send one fixes [Issue 2317](https://github.com/pgjdbc/pgjdbc/issues/2317) [PR #2319](https://github.com/pgjdbc/pgjdbc/pull/2319)

<!--more-->

**Commits by author**

Brett Okken (6):

* improv: Arrays in Object[] [PR 2230](https://github.com/pgjdbc/pgjdbc/pull/2230) [538c79f5](https://github.com/pgjdbc/pgjdbc/commit/538c79f560097e0fc8fef460477fbaeaa71ebb19)
* improv: Use jre utf-8 decoding [PR 2317](https://github.com/pgjdbc/pgjdbc/pull/2317) [a5786037](https://github.com/pgjdbc/pgjdbc/commit/a57860377053bd44008ae47453381b9e78442891)
* perf: improve performance of bytea string decoding [PR 2320](https://github.com/pgjdbc/pgjdbc/pull/2320) [f2a24d37](https://github.com/pgjdbc/pgjdbc/commit/f2a24d37363b59279290ef16767047bf65b3694c)
* feat: intern/canonicalize common strings [PR 2234](https://github.com/pgjdbc/pgjdbc/pull/2234) [a024cd51](https://github.com/pgjdbc/pgjdbc/commit/a024cd5187a7aa5843058fb825680a78ad047ca3)
* fix: numeric binary decode for even 10 thousands [PR 2327](https://github.com/pgjdbc/pgjdbc/pull/2327) [b3050e60](https://github.com/pgjdbc/pgjdbc/commit/b3050e60f81b4e43fae452bcf6df297df2048ae4)
* fix: remove unused OptimizedUTF8Encoder [PR 2329](https://github.com/pgjdbc/pgjdbc/pull/2329) [515ea066](https://github.com/pgjdbc/pgjdbc/commit/515ea066d2af84cbd98ab840457934df5596acfe)

Dave Cramer (5):

* Update debezium.yml [84f1057d](https://github.com/pgjdbc/pgjdbc/commit/84f1057d2b735b51c7ad8456f395c03104004867)
* update release date to Oct 18 [PR 2308](https://github.com/pgjdbc/pgjdbc/pull/2308) [5fc1976d](https://github.com/pgjdbc/pgjdbc/commit/5fc1976d4b3f3be2f62ede74497a5f7432647930)
* remove check for negative pid in cancel request. Apparently pgbouncer can send one fixes Issue [PR 2318](https://github.com/pgjdbc/pgjdbc/pull/2318) (#2319) [c9be5c0f](https://github.com/pgjdbc/pgjdbc/commit/c9be5c0f855bfbda1a481cd8b469210d13b2e553)
* move version to 42.3.0 [PR 2322](https://github.com/pgjdbc/pgjdbc/pull/2322) [1b8629b2](https://github.com/pgjdbc/pgjdbc/commit/1b8629b24e1851311df98bb390480dc7cbcdfb52)
* Remove references to JAVA 6 and 7 [PR 2312](https://github.com/pgjdbc/pgjdbc/pull/2312) [67113020](https://github.com/pgjdbc/pgjdbc/commit/67113020ac79dbad41d2aaf4f0cf6a9e0de4ef02)

Sergey Nuyanzin (1):

* [typo] typo in certdir/README.md [PR 2309](https://github.com/pgjdbc/pgjdbc/pull/2309) [e5e36bd3](https://github.com/pgjdbc/pgjdbc/commit/e5e36bd3e8ac87ae554ac5cd1ac664fcd0010073)

吴伟杰 (1):

* Fix typo in TimestampUtils.java [PR 2314](https://github.com/pgjdbc/pgjdbc/pull/2314) [4293a790](https://github.com/pgjdbc/pgjdbc/commit/4293a790d5fdea0c2c94b2911ce0da53539c85f2)

<a name="contributors_{{ page.version }}"></a>
### Contributors to this release

We thank the following people for their contributions to this release.

[Brett Okken](https://github.com/bokken)  
[Dave Cramer](davec@postgresintl.com)  
[Sergey Nuyanzin](https://github.com/snuyanzin)  
[吴伟杰](https://github.com/TeslaCN)  
