---
title:  PostgreSQL JDBC Driver 42.3.4 Released
date:   2022-04-15 11:00:00 -0400
categories:
    - new_release
version: 42.3.4
---

**Notable changes**

### Changed
- fix: change name of build cache [PR 2471](https://github.com/pgjdbc/pgjdbc/pull/2471)
- feat: add support for ResultSet#getObject(OffsetTime.class) and PreparedStatement#setObject(OffsetTime.class) [PR 2467](https://github.com/pgjdbc/pgjdbc/pull/2467)
- fix: Use non-synchronized getTimeZone in TimestampUtils [PR 2451](https://github.com/pgjdbc/pgjdbc/pull/2451)
- docs: Fix CHANGELOG.md misformatted markdown headings [PR 2461](https://github.com/pgjdbc/pgjdbc/pull/2461)
- docs:  remove loggerLevel and loggerFile from docs and issues [#2489](https://github.com/pgjdbc/pgjdbc/pull/2489)
- feat: use direct wire format -> LocalDate conversion without resorting to java.util.Date, java.util.Calendar,
  and default timezones [PR 2464](https://github.com/pgjdbc/pgjdbc/pull/2464) fixes Issue #2221

### Added

### Fixed
- docs: Update testing documentation [PR 2446](https://github.com/pgjdbc/pgjdbc/pull/2446)
- fix: Throw an exception if the driver cannot parse the URL instead of returning NULL fixes [Issue #2421](https://github.com/pgjdbc/pgjdbc/issues/2421)  [PR 2441](https://github.com/pgjdbc/pgjdbc/pull/2441)
- fix: Use PGProperty instead of the property names directly [PR 2444](https://github.com/pgjdbc/pgjdbc/pull/2444)
- docs: update changelog, missing links at bottom and formatting [PR 2460](https://github.com/pgjdbc/pgjdbc/pull/2460)
- fix: Remove isDeprecated from PGProperty. It was originally intended to help produce automated docs. Fixes #Issue 2479 [PR 2480](https://github.com/pgjdbc/pgjdbc/pull/2480)
- fix: change PGInterval parseISO8601Format to support fractional second [PR 2457](https://github.com/pgjdbc/pgjdbc/pull/2457)
- fix: More test and fix for issues discovered by [PR #2476](https://github.com/pgjdbc/pgjdbc/pull/2476) [PR #2488](https://github.com/pgjdbc/pgjdbc/pull/2488)

<!--more-->

**Commits by author**

Dave Cramer (8):

* docs: Update testing documentation [PR 2446](https://github.com/pgjdbc/pgjdbc/pull/2446)
* fix: Throw an exception if the driver cannot parse the URL instead of returning NULL fixes Issue [PR 2421](https://github.com/pgjdbc/pgjdbc/pull/2421) (#2441)
* fix: Use PGProperty instead of the property names directly [PR 2444](https://github.com/pgjdbc/pgjdbc/pull/2444)
* docs: update changelog, missing links at bottom and formatting [PR 2460](https://github.com/pgjdbc/pgjdbc/pull/2460)
* added post for 42.2.25 [PR 2466](https://github.com/pgjdbc/pgjdbc/pull/2466)
* change name of build cache [PR 2471](https://github.com/pgjdbc/pgjdbc/pull/2471)
* Remove isDeprecated from PGProperty. It was originally intended to help produce automated docs. Fixes #Issue 2479 [PR 2480](https://github.com/pgjdbc/pgjdbc/pull/2480)

Fabio Cechinel Veronez (1):

* docs: Fix CHANGELOG.md misformatted markdown headings [PR 2461](https://github.com/pgjdbc/pgjdbc/pull/2461)

Uwe Schindler (2):

* feat: add support for ResultSet#getObject(OffsetTime.class) and PreparedStatement#setObject(OffsetTime.class) [PR 2467](https://github.com/pgjdbc/pgjdbc/pull/2467)

Wei Su (1):
* GSS login to use TGT from keytab fixes [Issue 2469](https://github.com/pgjdbc/pgjdbc/issues/2469) [PR 2470](https://github.com/pgjdbc/pgjdbc/pull/2470)

paulo-kluh (1):

* fix: change PGInterval parseISO8601Format to support fractional second [PR 2457](https://github.com/pgjdbc/pgjdbc/pull/2457)

吴伟杰 (1):

* Use non-synchronized getTimeZone in TimestampUtils [PR 2451](https://github.com/pgjdbc/pgjdbc/pull/2451)

<a name="contributors_{{ page.version }}"></a>
### Contributors to this release

We thank the following people for their contributions to this release.

[Uwe Schindler](https://github.com/uschindler)  
[Wei Su](https://github.com/suwei111333)  
[Fabio Cechinel Veronez](https://github.com/fcv)  
[paulo-kluh](https://github.com/paulo-kluh)
[吴伟杰](https://github.com/TeslaCN)  
